
import hexagons;
import random;
import objects;

import math;

tree_count = 0;
minion_count = 0;

def populate_with_trees(hexagon):
    global tree_count;
    min_x = hexagon.x - hexagon.radius;
    max_x = hexagon.x + hexagon.radius;
    min_y = hexagon.y - hexagon.radius;
    max_y = hexagon.y + hexagon.radius;
    
    # choose a uniform random point in the box
    
    for i in range(100):
        r_x = random.random()*(max_x - min_x) + min_x;
        r_y = random.random()*(max_y - min_y) + min_y;
    
        if not hexagon.is_point_inside(r_x, r_y):
            continue;
        
        hexagon.objects.append(objects.GameObject("tree", r_x, r_y, random.random() * 2. * math.pi, 1., hexagon));
        tree_count += 1;

def populate_with_enemies(hexagon):
    global minion_count;
    min_x = hexagon.x - hexagon.radius;
    max_x = hexagon.x + hexagon.radius;
    min_y = hexagon.y - hexagon.radius;
    max_y = hexagon.y + hexagon.radius;
    for i in range(2):
        r_x = random.random()*(max_x - min_x) + min_x;
        r_y = random.random()*(max_y - min_y) + min_y;
        
        if not hexagon.is_point_inside(r_x, r_y):
            continue;
        
        hexagon.objects.append(objects.Character(r_x, r_y, random.random() * 2. * math.pi, hexagon, "minion"));
        minion_count += 1;

def environment():
    hexagon_grid = hexagons.HexagonGrid(30.);
    
    for i in range(0,10):
        for j in range(i*6+1):
            hexagon = hexagon_grid.get(i, j);
            hexagon.objects = [];
            hexagon.floor = None;
            populate_with_trees(hexagon);
            populate_with_enemies(hexagon);
            
    # now the starting hexagons on the left
    hexagon = hexagon_grid.get(10, 10*3);
    hexagon.objects = [];
    hexagon.floor = "semi_walled";
    hexagon = hexagon_grid.get(11, 11*3);
    hexagon.objects = [];
    hexagon.floor = "semi_walled";
    hexagon = hexagon_grid.get(12, 12*3);
    hexagon.objects = [];
    hexagon.floor = "semi_walled";

    print "Environment with", tree_count, "trees and ", minion_count, "minions";
    return hexagon_grid;
